#include "FROG_Camera.h"

FROG_Camera::FROG_Camera(void)
{
	target_x = 0;
	target_y = 0;
	target_z = 0;

	R        = 700.0f;
	phi      = 0.0f;
	theta    = 0.0f;
}

FROG_Camera::~FROG_Camera(void)
{
}

void FROG_Camera::LookAt()
{
	dir_x    = - 1*cos(phi)*cos(theta);
	dir_y    =   1         *sin(theta);
	dir_z    = - 1*sin(phi)*cos(theta);

	vert_x   = cos(phi)*sin(theta);
	vert_y   =          cos(theta);
	vert_z   = sin(phi)*sin(theta);

	// Defini la camera (pos.x, pos.y, poz.z,   view.x, view.y, view.z,   vert.x, vert.y vert.z)  pos est la position de la camera, view est l'endroit ou elle regarde, et vert est le vecteur qui indique la verticale de la camera	
	gluLookAt (target_x + R*dir_x, target_y + R*dir_y, target_z + R*dir_z, 		       
			   target_x          , target_y          , target_z,
			   vert_x            , vert_y            , vert_z  );	
}

void FROG_Camera::Move(float dx, float dy)
{
	if(dy!=0){
		target_x += dy * vert_x;
		target_y += dy * vert_y;
		target_z += dy * vert_z;
	}
	if(dx!=0){
		target_x += dx * (dir_y*vert_z - dir_z*vert_y);
		target_y += dx * (dir_z*vert_x - dir_x*vert_z);
		target_z += dx * (dir_x*vert_y - dir_y*vert_x);
	}

}

void FROG_Camera::Reset()
{
	target_x = 0;
	target_y = 0;
	target_z = 0;

	R        = 700.0f;
	phi      = 0.0f;
	theta    = 0.0f;
}

void FROG_Camera::SwitchCamLight_On(){
	FROG_Light::SwitchLight_On(target_x + R*dir_x, target_y + R*dir_y, target_z + R*dir_z);
}
