#ifndef _FROG_CAMERA_H__
#define _FROG_CAMERA_H__

#ifdef linux
 #include <GL/gl.h>
 #include <GL/glu.h> 
#elif macos
 #include <OpenGL/gl.h>
 #include <OpenGL/glu.h>
#else
 #include <windows.h>
 #include <gl/gl.h>
 #include <gl/glu.h>
#endif
#include <stdio.h>
#include <math.h>

#include "FROG_Light.h"

class FROG_Camera
{
public:
	FROG_Camera(void);
public:
	~FROG_Camera(void);
		
	void LookAt();
	void Reset();
	void Move(float dx, float dy);

	void SwitchCamLight_On();

	float dir_x;
	float dir_y;
	float dir_z;

	float target_x;
	float target_y;
	float target_z;

	float vert_x;
	float vert_y;
	float vert_z;

	float phi;
	float theta;
	float R;	
};

#endif

