#ifndef _FROG_ELEMENT_EVENT_CALOHIT_H__
#define _FROG_ELEMENT_EVENT_CALOHIT_H__

#include "FROG_Element_Base.h"
#include "FROG_Objects_Extended.h"

class FROG_Element_Event_CaloHit : public FROG_Element_Base_With_DetId {
public :
    float E; float t; 
	FROG_Objects_Extended*  frogObjects_;
	double EMin_;
	unsigned int nameId_;

    virtual bool isCompactible(){ return true; }

    static unsigned int sizeOf(){ return FROG_Element_Base_With_DetId::sizeOf() + 2*sizeof(float); }

    FROG_Element_Event_CaloHit( unsigned int DetId, float E_, float t_):
    FROG_Element_Base_With_DetId(C_RECO_CALOHIT, DetId),
    E(E_),t(t_)
    {
            size_ = sizeOf();
    }

    FROG_Element_Event_CaloHit(FILE* pFile) : FROG_Element_Base_With_DetId(C_RECO_CALOHIT)
    {
            size_ = sizeOf();
            fread(&detId_        ,sizeof(detId_)      ,1,pFile);
            fread(&E             ,sizeof(E)           ,1,pFile);
            fread(&t             ,sizeof(t)           ,1,pFile);			
    }

    virtual void write () {
            size_ = sizeOf();
            data_ = new unsigned char[size_-6];
            data_ = FillBuffer( data_, &detId_,          sizeof(detId_));
            data_ = FillBuffer( data_, &E,               sizeof(E));
            data_ = FillBuffer( data_, &t,               sizeof(t));
            data_ = (unsigned char*)((unsigned long)data_ - (size_-6) );
    }

	virtual void printInfos(char* buffer){		
		sprintf(buffer,"CaloHit : DetId=%i E=%7.2f t=%8.3f",detId_,E, t);
	}

    #ifdef FROG_OPENGL	
    virtual void display(bool UseDisplayList=true, float* color=NULL){			
		// first Init Colors & Style!
		init(NULL);
		if(E<EMin_){return;}
		if(color){glColor4fv(color);}else{glColor4fv(style_->color_);}

		if(Start_Display(UseDisplayList)){			
			if(FROG_Element_Geom_CaloMod* cell = dynamic_cast<FROG_Element_Geom_CaloMod*>(frogObjects_->frogGeom_->FindByDetId(	detId_ ))){								
				glLoadName( nameId_ );
				cell->displayE( 0.75*log10(E/EMin_), color,0,NULL,style_->ShowDet_);
			}
			End_Display(UseDisplayList);
		}

    }
    #endif

	virtual void init(void* frogObjects){
		
		if(frogObjects!=NULL){
			frogObjects_ = (FROG_Objects_Extended*) frogObjects;
			nameId_      = frogObjects_->frogEvent_->name_map.size();
			frogObjects_->frogEvent_->name_map.push_back(this);
		}else if(frogObjects==NULL && frogObjects_ != NULL){
			style_ = mother_->style_;
			EMin_  = style_->EMin_;

			if(EMin_<0){
				FROG_Element_Base* tmp = frogObjects_->frogGeom_->FindByDetId(detId_);
				if(tmp){
					tmp->init(NULL);
					if(tmp->style_)EMin_ = tmp->style_->EMin_;
				}
			}
			style_->EMin_ = EMin_;

		}				
	}
};

#endif
