#ifndef _FROG_ELEMENT_EVENT_MET_H__
#define _FROG_ELEMENT_EVENT_MET_H__

#include "FROG_Element_Event_Candidate.h"

class FROG_Element_Event_MET : public FROG_Element_Event_Candidate {
public :
    float SumEt_;
	
public :
	virtual bool isCompactible(){ return true; }

	static unsigned int sizeOf(){ return FROG_Element_Event_Candidate::sizeOf() + sizeof(float);}

	FROG_Element_Event_MET(int PdgId, float P, float Eta, float Phi, float SumEt ) : 
		FROG_Element_Event_Candidate(PdgId,P,Eta,Phi), SumEt_(SumEt)
	{    
		type_ = C_RECO_MET;
		size_ = sizeOf();
	}

	FROG_Element_Event_MET(FILE* pFile) : FROG_Element_Event_Candidate()
	{   
                type_ = C_RECO_MET;
		size_ = sizeOf();
		fread(&PdgId_        ,sizeof(PdgId_)      ,1,pFile);
		fread(&P_            ,sizeof(P_)          ,1,pFile);
    	fread(&Eta_          ,sizeof(Eta_)        ,1,pFile);
    	fread(&Phi_          ,sizeof(Phi_)        ,1,pFile);		
    	fread(&SumEt_          ,sizeof(SumEt_)    ,1,pFile);		
	}

	virtual void write () {
		size_ = sizeOf();
		data_ = new unsigned char[size_-6];
		data_ = FillBuffer( data_, &PdgId_,             sizeof(PdgId_));
		data_ = FillBuffer( data_, &P_,                 sizeof(P_));
	    data_ = FillBuffer( data_, &Eta_,               sizeof(Eta_));
        data_ = FillBuffer( data_, &Phi_,               sizeof(Phi_));			
		data_ = FillBuffer( data_, &SumEt_,             sizeof(SumEt_));			
		data_ = (unsigned char*)((unsigned long)data_ - (size_-6) );		
	}

        virtual void printInfos(char* buffer){
			sprintf(buffer,"MET : P=%7.2f Eta=%+6.2f Phi=%6.2f SumEt=%7.2f", P_, Eta_, Phi_, SumEt_);
        }

        virtual void init(void* frogObjects){
            if(frogObjects!=NULL){
                    frogObjects_ = (FROG_Objects_Extended*) frogObjects;
                    nameId_      = frogObjects_->frogEvent_->name_map.size();
                    frogObjects_->frogEvent_->name_map.push_back(this);
            }else if(frogObjects==NULL && frogObjects_ != NULL){
                    if(mother_ != NULL){    style_ = new FROG_Objects_Style(mother_->style_);
                    }else{                                  style_ = new FROG_Objects_Style();                              }

                    frogObjects_->frogCard_->GetColor(style_->color_,"Id_%i_MET_Color",((FROG_Element_Base_With_DetId*)mother_)->DetId());
            }
        }

};
#endif
