// FrogReadElements.h.h: TO EDIT
//                       TO EDIT
//                       TO EDIT
//////////////////////////////////////////////////////////////////////
#ifndef _FROG_ELEMENT_TOOLS__
#define _FROG_ELEMENT_TOOLS__

#include <vector>
#include <map>
#include <algorithm>

#include "FROG_Chunk.h"
#include "FROG_Events.h"

#include "FROG_Element_Base.h"
#include "FROG_Element_Base_With_DetId.h"
#include "FROG_Element_Base_With_DetId_And_Name.h"

#include "FROG_Element_Geom_TrackerMod.h"
#include "FROG_Element_Geom_CaloMod.h"

#include "FROG_Element_Primitive_CustomCube.h"
#include "FROG_Element_Primitive_Cube.h"
#include "FROG_Element_Primitive_Sphere.h"
#include "FROG_Element_Primitive_PartialSphere.h"
#include "FROG_Element_Primitive_Cylinder.h"

#include "FROG_Element_Primitive_CustomSurface.h"
#include "FROG_Element_Primitive_Rectangle.h"
#include "FROG_Element_Primitive_Disc.h"

#include "FROG_Element_Primitive_Line.h"
#include "FROG_Element_Primitive_Circle.h"

#include "FROG_Element_Event_Sim_Track.h"
#include "FROG_Element_Event_Sim_Vertex.h"
#include "FROG_Element_Event_Sim_Hit.h"

#include "FROG_Element_Event_Hit.h"
#include "FROG_Element_Event_Cluster_SiStrip.h"
#include "FROG_Element_Event_CaloHit.h"
#include "FROG_Element_Event_CaloTower.h"
#include "FROG_Element_Event_Segment.h"
#include "FROG_Element_Event_Track.h"
#include "FROG_Element_Event_NuclInt.h"
#include "FROG_Element_Event_Jet.h"
#include "FROG_Element_Event_Candidate.h"
#include "FROG_Element_Event_MET.h"

namespace FROG_ELEMENT{
 
	unsigned int Read      (FILE* pFile, FROG_Element_Base* mother, unsigned int NBytes_ToRead);
	void		 PrintTree (FROG_Element_Base* mother, unsigned int level=0);
	void		 PrintTree (FILE* pfile, FROG_Element_Base* mother, unsigned int level=0);
	void		 PrintSelection (FILE* pfile, FROG_Element_Base* mother, unsigned int level=0, double zmin=0, double zmax=0);
	void		 PrintSelection2(FILE* pfile, FROG_Element_Base* mother, int component, double x, double y, double z);
	bool         CreateSubMenu(unsigned int mother_menu, FROG_Element_Base* mother, void (*func)(int value),unsigned int level);
}

#endif


