// FROG_Font.h: interface for the FROG_Font class.
//////////////////////////////////////////////////////////////////////

#ifndef _FROG_FONT_H__
#define _FROG_FONT_H__


#ifdef linux
	#include <GL/gl.h>
	#include <GL/glu.h> 
	#include "../GLUT/glut.h"
#elif macos
        #include <OpenGL/gl.h>
        #include <OpenGL/glu.h>
        #include <GLUT/glut.h>
#else		
	#include <windows.h> 
	#include <atlstr.h>
	#include <gl/gl.h>
	#include <gl/glu.h>
	#include <gl/glut.h>
#endif

class FROG_Font{
private : 
	GLuint	 base;
	unsigned char height;
public :
	FROG_Font(void* FONT_ID, unsigned char Height=0){
		height = Height;

		base = glGenLists(96);
		for(unsigned int i=32;i<128;i++){
			glNewList(base+i-32, GL_COMPILE);
				glutBitmapCharacter(FONT_ID, i);
			glEndList();
		}
	}
	virtual ~FROG_Font(){
		glDeleteLists(base, 96);
	}

	void glPrint(const char *fmt, ...){
		if (fmt == NULL)	return;											

		char	text[256];
		va_list	ap;		
		va_start(ap, fmt);			
		vsprintf(text, fmt, ap);
		va_end(ap);					

		glPushAttrib(GL_LIST_BIT);							
		glListBase(base - 32);								
		glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);
		glPopAttrib();
	}

	void glPrint(int x, int y, const char *fmt, ...){
		if (fmt == NULL)	return;											

		char	text[256];
		va_list	ap;		
		va_start(ap, fmt);			
		vsprintf(text, fmt, ap);
		va_end(ap);					

		glRasterPos2i((int)x,(int)y);

		glPushAttrib(GL_LIST_BIT);							
		glListBase(base - 32);								
		glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);
		glPopAttrib();
	}

	void glTextPrint(int x, int y, const char *fmt, ...){
		if (fmt == NULL)	return;											

		char	text[256];
		va_list	ap;		
		va_start(ap, fmt);			
		vsprintf(text, fmt, ap);
		va_end(ap);					

		glRasterPos2i((int)x,(int)y);

		glPushAttrib(GL_LIST_BIT);							
		glListBase(base - 32);								
		for(unsigned int i=0;i<strlen(text);i++){
			if(text[i]=='\n'){
				y-=height;
				glRasterPos2i((int)x,(int)y);				
			}else{				
				glCallLists(1, GL_UNSIGNED_BYTE, &text[i]);
			}
		}
		glPopAttrib();
	}
};


#endif


