// Geometry.h: interface for the Geometry class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _FROG_GEOMETRY_H__
#define _FROG_GEOMETRY_H__

#include "FROG_Element_Base_With_DetId.h"

#ifdef FROG_ZLIB
	#include "FROG_ZLib.h"
#endif

#ifdef linux
 #include <ext/hash_map>
 using namespace __gnu_cxx;
 typedef hash_map<unsigned int, FROG_Element_Base*, hash<unsigned int>, equal_to<unsigned int> > Frog_map;
 typedef hash_map<unsigned int, FROG_Element_Base*, hash<unsigned int>, equal_to<unsigned int> >::iterator Frog_map_it;
#elif macos
 #include <ext/hash_map>
 using namespace __gnu_cxx;
 typedef hash_map<unsigned int, FROG_Element_Base*, hash<unsigned int>, equal_to<unsigned int> > Frog_map;
 typedef hash_map<unsigned int, FROG_Element_Base*, hash<unsigned int>, equal_to<unsigned int> >::iterator Frog_map_it;
#else
 #include <hash_map>
 using namespace stdext;
 typedef hash_map<unsigned int, FROG_Element_Base*, hash_compare<unsigned int, std::less<unsigned int> > > Frog_map;
 typedef hash_map<unsigned int, FROG_Element_Base*, hash_compare<unsigned int, std::less<unsigned int> > >::iterator Frog_map_it;
#endif

class FROG_Geometry
{
public:
	FROG_Geometry() : prim(NULL) {}
	FROG_Geometry(FROG_Element_Base* elt): prim(elt) {}
	~FROG_Geometry(void){}

	void Load (char* path);
	void Save (char* path);
    void Save (char* path, bool CompressFiles);

	void updateGeomToDisplay(void* frogObjects_);
	void updateGeomToDisplay(vector<unsigned int> geometryToDisplay);
	void display();

	FROG_Element_Base*  FindByDetId(unsigned int DetId);
	FROG_Element_Base*  prim;

private :	
	Frog_map            mapByDetId;
	void FillMap(FROG_Element_Base* elt);

	std::vector<unsigned int> GeomToDisplay;
};

#endif
