// FROG_View_LegoPlot_CaloJet.h
//
//////////////////////////////////////////////////////////////////////

#ifndef _FROG_VIEW_LEGOPLOT_CALOJET_H__
#define _FROG_VIEW_LEGOPLOT_CALOJET_H__

#include "FROG_View_LegoPlot_CaloTower.h"

class FROG_View_LegoPlot_CaloJet : public FROG_View_LegoPlot_CaloTower{
public :
	FROG_View_LegoPlot_CaloJet(char* Name, FROG_Objects_Extended* frogObjects) : FROG_View_LegoPlot_CaloTower(Name, frogObjects){
		Type_              = 13;

		cam_->R     = 150;
		cam_->theta = 0.5;
		cam_->phi   = 4.3;
	}

	virtual void Display_Core(){
		if(frogObjects_ && frogObjects_->selectedObject_ && frogObjects_->selectedObject_DisplayFlag){
			FROG_Element_Event_Jet* jet = dynamic_cast<FROG_Element_Event_Jet*>(frogObjects_->selectedObject_);
			if(jet){
				float color[4] = {1 - frogObjects_->selectedObject_->style_->color_[0],1 - frogObjects_->selectedObject_->style_->color_[1],1 - frogObjects_->selectedObject_->style_->color_[2],1};
				Draw_Jet_LegoPlot(jet,color);
			}
		}

		Display_Grid();		
		Display_Jets();
	}

	void Display_Jets(){	
		if(!frogObjects_ || !frogObjects_->frogEvent_) return;

		FROG_Element_Base_With_DetId* Coll = (FROG_Element_Base_With_DetId*)frogObjects_->frogEvent_->FindByDetId(EVTID_JET_CALO);
		if(!Coll){return;}

		std::vector<FROG_Element_Base*> CaloJets;
		Coll->GetFullDaughtersVector(&CaloJets);

		for(unsigned int i=0;i<CaloJets.size();i++){
			FROG_Element_Event_Jet* jet = dynamic_cast<FROG_Element_Event_Jet*>(CaloJets[i]);
			if(!jet)continue;

			Draw_Jet_LegoPlot(jet);
		}		

/*
		DrawCube(0 ,0 ,0 ,
				 10,0 ,0 ,
				 10,10,0 ,
				 0 ,10,0 ,
				 0 ,0 ,10,
				 10,0 ,10,
				 10,10,10,
				 0 ,10,10);
*/
}

	void Draw_Jet_LegoPlot(FROG_Element_Event_Jet* jet, float* color=NULL){

		if(jet->Components_Vector_.size()>0){
			FROG_Element_Base_With_DetId* Coll = (FROG_Element_Base_With_DetId*)frogObjects_->frogEvent_->FindByDetId(jet->Components_CollEvtId_);
			if(!Coll)return;

			jet->init(NULL);
			if(jet->P_<jet->style_->EMin_){return;}
			if(FROG_COORD::GetPt(jet->P_,jet->Eta_)<jet->style_->PtMin_){return;}

			glLoadName( jet->nameId_ );
			for(unsigned int i=0;i<jet->Components_Vector_.size();i++){
				FROG_Element_Event_CaloTower* Tower = dynamic_cast<FROG_Element_Event_CaloTower*>(Coll->FindByDetId_FromMap(jet->Components_Vector_[i]));
				if(Tower){
					if(color){Draw_Tower_LegoPlot(Tower,color);}
					else     {Draw_Tower_LegoPlot(Tower,jet->style_->color_);}
				}
			}
		}
	}

};


#endif

