// FROG_View.h: interface for the FROG_View class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _FROG_VIEW_MENU_H__
#define _FROG_VIEW_MENU_H__

#include "FROG_View.h"
#include "FROG_Element_Base_With_DetId.h"

class FROG_View_Menu : public FROG_View{
public : 
	struct MenuEntry{FROG_Element_Base* Object; char Name[255]; char Level; unsigned int Id; unsigned int Daughters;};
	class Order {
	public:
		bool operator () (MenuEntry* a, MenuEntry* b){
		//	return (a->type() < b->type());

//			FROG_Element_Base_With_DetId_And_Name* FEBDN1 = dynamic_cast<FROG_Element_Base_With_DetId_And_Name*>(a->Object);
//			FROG_Element_Base_With_DetId_And_Name* FEBDN2 = dynamic_cast<FROG_Element_Base_With_DetId_And_Name*>(b->Object);
//			FROG_Element_Base_With_DetId* FEBD = dynamic_cast<FROG_Element_Base_With_DetId*>(mother);
//			if(a.Object->getMother() == b.Object->getMother() && a.Level==b.Level && FEBDN1 && FEBDN2)return (bool)strcmp(a.Name,b.Name);
			return 0;
		}
	};
	
	std::vector<MenuEntry*> Entries_;	
	unsigned int Imin;
	unsigned int Imax;

	bool ShowDet;
	bool ShowBox;

	bool		 State;

	unsigned int BoxH;	
	float        Alpha;
	float        AlphaFx;

public :
	FROG_View_Menu(char* Name, FROG_Objects_Extended* frogObjects=NULL) : FROG_View(Name, frogObjects){
		Type_     = 99;

		State = false;
		AlphaFx = 0;

		Alpha   = 0.7;
		if(frogObjects_ && frogObjects_->frogCard_){			
			State   = frogObjects_->frogCard_->GetBool (false		, "%s_Visible" , Name_);
			ShowDet = frogObjects_->frogCard_->GetBool (true		, "%s_ShowId"  , Name_);
			ShowBox = frogObjects_->frogCard_->GetBool (true		, "%s_ShowBox" , Name_);
			          frogObjects_->frogCard_->GetFloat(&Alpha	    , "%s_Alpha"   , Name_);
		}			
		if(ShowBox){	BoxH = 100; }else{ BoxH = 0;}

		Imin = 0;
		Imax = 0;

		Menu_CleanUp();			
		if(frogObjects_->frogEvent_)Menu_Update(frogObjects_->frogEvent_);
		if(frogObjects_->frogGeom_ )Menu_Update(frogObjects_->frogGeom_->prim->getDaughter(0));
	}

	virtual ~FROG_View_Menu(){
		Menu_CleanUp();
	}

	virtual bool IsSwapPossible(){return false;}

	void Effects(){
		if(State){
			if(AlphaFx<1) AlphaFx += 0.025;
		}else{
			if(AlphaFx>0) AlphaFx -= 0.025;
		}
	}

	void Display_Begin(){		
		glViewport (0, 0, ww_, wh_);
		glMatrixMode(GL_PROJECTION);
		glPushMatrix();
		glLoadIdentity();
		glOrtho(0, ww_, 0, wh_, -1.0f, 1.0f);
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
		glLoadIdentity();
		glPushAttrib(GL_DEPTH_TEST);
		glDisable(GL_DEPTH_TEST);
	}

	void Display_End(){
		glPopAttrib();
		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
		glMatrixMode(GL_MODELVIEW);
		glPopMatrix();	
	}

	virtual void Display(){
		if(State==false && AlphaFx <= 0)return;

		Display_Begin();
		Effects();
		Menu_Display();		
		Display_End();	
	}


	void Menu_Display(){	
		Menu_CleanUp();			
		if(frogObjects_->frogEvent_)Menu_Update(frogObjects_->frogEvent_);
		if(frogObjects_->frogGeom_ )Menu_Update(frogObjects_->frogGeom_->prim->getDaughter(0));


		Imax = Imin - 1 + (vh_-BoxH)/15;

		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);


		// ARRAY CONTENT
		for(unsigned int i=Imin;i<Imax;i++){	

			int ymin = vy_ + vh_ - (i+1-Imin)*15;
			int ymax = vy_ + vh_ - (i  -Imin)*15;	

			if(i==Imax-1){	ymin = vy_ + BoxH;	}

			glColor4f (0.9,0.9,0.9,Alpha*AlphaFx);			
			if(i<Entries_.size() && Entries_[i]->Object){
				if(Entries_[i]->Object->getDisplay()==0)glColor4f (1.0,0.8,0.8,Alpha*AlphaFx);
				if(Entries_[i]->Object->getDisplay()==1)glColor4f (0.8,1.0,0.8,Alpha*AlphaFx);
				if(Entries_[i]->Object->getDisplay()>=2)glColor4f (0.8,0.8,1.0,Alpha*AlphaFx);
			}

			glBegin (GL_QUADS);
				glVertex2i (vx_			 , ymin);
				glVertex2i (vx_ + vw_-20 , ymin);
				glVertex2i (vx_ + vw_-20 , ymax);
				glVertex2i (vx_			 , ymax);
			glEnd (); 

			if(i>=Entries_.size())continue;
		
			glColor4f (0,0,0,1*AlphaFx);
			if(Entries_[i]->Object->getDisplay()==0){
				frogObjects_->frogFonts_->Font_Fixed_9_by_15->glPrint(vx_ + 5                , ymax-12 ,"OFF");
			}else if(Entries_[i]->Object->getDisplay()==1){
				frogObjects_->frogFonts_->Font_Fixed_9_by_15->glPrint(vx_ + 5                , ymax-12 ,"ON");
			}else{
				frogObjects_->frogFonts_->Font_Fixed_9_by_15->glPrint(vx_ + 5                , ymax-12 ,"MIX");
			}

			if(Entries_[i]->Object->getDaughterSize()>0){
				if(Entries_[i]->Object->MenuOpened_==false){
					frogObjects_->frogFonts_->Font_Fixed_9_by_15->glPrint(vx_ + 45           , ymax-12 ,"+");
				}else{
					frogObjects_->frogFonts_->Font_Fixed_9_by_15->glPrint(vx_ + 45           , ymax-12 ,"-");
				}
			}else{
				;
			}

			if(ShowDet && Entries_[i]->Id>0){
				frogObjects_->frogFonts_->Font_Fixed_9_by_15->glPrint(vx_ + vw_-115      , ymax-12 ,"%9i",Entries_[i]->Id);
				frogObjects_->frogFonts_->Font_Fixed_9_by_15->glPrint(vx_ + vw_-170      , ymax-12 ,"%4i",Entries_[i]->Daughters);
			}

			frogObjects_->frogFonts_->Font_Fixed_9_by_15->glPrint(vx_ + 65+20*Entries_[i]->Level, ymax-12 ,Entries_[i]->Name);			
		}

		// SCROLL BAR			
		float Cursor_H = 1+(vh_-BoxH -40);
		if( ((Imax-Imin+1)/(float)Entries_.size()) <1) Cursor_H *=  ((Imax-Imin+1) / (float) Entries_.size());		
		float Cursor_Y = 0-Cursor_H/2 + (vh_-20) - (vh_-BoxH-40) * (Imin / (float) Entries_.size());
		if(Cursor_H<5)Cursor_H=5;

		glBegin (GL_QUADS);
			glColor4f (0.9,0.9,0.9,Alpha*AlphaFx);
			glVertex2i (vx_ + vw_    , vy_ + vh_);			
			glVertex2i (vx_ + vw_-20 , vy_ + vh_);
			glVertex2i (vx_ + vw_-20 , vy_ + BoxH);
			glVertex2i (vx_ + vw_    , vy_ + BoxH);

			glColor4f (0.5,0.5,0.5,Alpha*AlphaFx);
			glVertex2i (vx_ + vw_    , vy_ + vh_);			
			glVertex2i (vx_ + vw_-20 , vy_ + vh_);
			glVertex2i (vx_ + vw_-20 , vy_ + vh_-20);
			glVertex2i (vx_ + vw_    , vy_ + vh_-20);

			glColor4f (0.5,0.5,0.5,Alpha*AlphaFx);
			glVertex2i (vx_ + vw_    , vy_ + BoxH + 20);			
			glVertex2i (vx_ + vw_-20 , vy_ + BoxH + 20);
			glVertex2i (vx_ + vw_-20 , vy_ + BoxH);
			glVertex2i (vx_ + vw_    , vy_ + BoxH);

			glColor4f (0.3,0.3,0.3,Alpha*AlphaFx);
			glVertex2i (vx_ + vw_    , vy_ + (int)(Cursor_Y + Cursor_H/2));			
			glVertex2i (vx_ + vw_-20 , vy_ + (int)(Cursor_Y + Cursor_H/2));
			glVertex2i (vx_ + vw_-20 , vy_ + (int)(Cursor_Y - Cursor_H/2));
			glVertex2i (vx_ + vw_    , vy_ + (int)(Cursor_Y - Cursor_H/2));
		glEnd (); 

		// BOTTOM BOX
		if(ShowBox){
			glColor4f (1,1,1,Alpha*AlphaFx);
			glBegin (GL_QUADS);
				glVertex2i (vx_ + vw_    , vy_ + BoxH);
				glVertex2i (vx_          , vy_ + BoxH);
				glVertex2i (vx_          , vy_ + 0);
				glVertex2i (vx_ + vw_    , vy_ + 0);
			glEnd (); 

			glColor4f (0,0,0,1*AlphaFx);
			frogObjects_->frogFonts_->Font_Helvetica_18->glPrint(vx_ + 10, vy_ + 70 ,"This Info Box is not yet ready");
			frogObjects_->frogFonts_->Font_Helvetica_18->glPrint(vx_ + 10, vy_ + 40 ,"But will contain useful informations (e.g. style)");
			glColor4f (1,0,0,1*AlphaFx);
			frogObjects_->frogFonts_->Font_Helvetica_18->glPrint(vx_ + 10, vy_ + 10 ,"Please, send us your feedbacks and/or requirements!");
		}

		// STRUCTURE LINES
		glColor4f (0,0,0,Alpha*AlphaFx);
		glBegin (GL_LINES);
			glVertex2i (vx_ + 40    , vy_ + BoxH);
			glVertex2i (vx_ + 40	, vy_ + vh_);

			glVertex2i (vx_ + 60    , vy_ + BoxH);
			glVertex2i (vx_ + 60	, vy_ + vh_);

			glVertex2i (vx_ + vw_-20, vy_ + BoxH);
			glVertex2i (vx_ + vw_-20, vy_ + vh_);

			if(ShowDet){
			glVertex2i (vx_ + vw_-120, vy_ + BoxH);
			glVertex2i (vx_ + vw_-120, vy_ + vh_);

			glVertex2i (vx_ + vw_-180, vy_ + BoxH);
			glVertex2i (vx_ + vw_-180, vy_ + vh_);
			}

			glVertex2i (vx_ + 0     , vy_ + BoxH);
			glVertex2i (vx_ + vw_   , vy_ + BoxH);
		glEnd (); 

	}

	void Menu_Update(FROG_Element_Base* mother=NULL, char Level=0){
		FROG_Element_Base_With_DetId_And_Name* FEBDN = dynamic_cast<FROG_Element_Base_With_DetId_And_Name*>(mother);
		FROG_Element_Base_With_DetId*          FEBD  = dynamic_cast<FROG_Element_Base_With_DetId*>(mother);

		MenuEntry* tmp = new MenuEntry;
		tmp->Object      = mother;
		tmp->Level       = Level;
		tmp->Id			 = 0;
		tmp->Daughters   = mother->getDaughterSize();
		if(FEBD)tmp->Id = FEBD->DetId();		

		if(FEBDN){					
			strcpy(tmp->Name,FEBDN->Name());
			//sprintf(tmp->Name,"%s DetId = %i",tmp->Name, FEBDN->DetId());
		}else if(FEBD){				
			//sprintf(tmp->Name,"DetId = %i",FEBD->DetId());
			mother->printInfos(tmp->Name);
		}else if(mother->type()==C_GEOMETRY){
			sprintf(tmp->Name,"Geometry");			
		}else if(mother->type()<=C_EVENTRT && mother->type()>=C_EVENT){
			sprintf(tmp->Name,"Event");			
		}else{			
			mother->printInfos(tmp->Name);		
		}

		Entries_.push_back(tmp);

		if(mother->MenuOpened_){
			for(unsigned int i=0;i<mother->getDaughterSize();i++){
				Menu_Update(mother->getDaughter(i),Level+1);
			}
		}
	}

	void Menu_CleanUp(){
		while( !Entries_.empty() ){
			delete Entries_.back();
			Entries_.pop_back();
		}
	}

	//frogObjects_->selectedObject_


bool processMouse(int button, int state, int x, int y)
{	
	if(State==false && AlphaFx <= 0)return false;
	
	unsigned int X = (unsigned int)       x ;
	unsigned int Y = (unsigned int)(wh_ - y);

	if(Y<vy_ || Y>vy_ + vh_)return false;
	if(X<vx_ || X>vx_ + vw_)return false;
	if(Y < vy_ + BoxH)return true;

	unsigned int Row = ((vy_ + vh_ - Y)/15)+Imin;	

	if(button == GLUT_LEFT_BUTTON){
		if(state ==  GLUT_DOWN){
			if(X<vx_ + 40 && Row<Entries_.size()){					
				char PrevDisplay = Entries_[Row]->Object->getDisplay();
				if(PrevDisplay==0){
					Entries_[Row]->Object->setDisplay(1);	
				}else{
					Entries_[Row]->Object->setDisplay(0);
				}
				frogObjects_->frogGeom_->prim->setDisplay(2);	
				if(frogObjects_->frogEvent_)frogObjects_->frogEvent_->setDisplay(2);
				return true;

			}else if(X<vx_ + 60 && Row<Entries_.size()){
				if(Entries_[Row]->Object->MenuOpened_==true){
					Entries_[Row]->Object->MenuOpened_=false;				
				}else{
					Entries_[Row]->Object->MenuOpened_ = true;
				}
				return true;

			}else if(X>=vx_ + (int)(vw_-20)){
				float Cursor_H = (vh_- BoxH - 40);
				if( ((Imax-Imin+1)/(float)Entries_.size()) <1) Cursor_H *=  ((Imax-Imin+1) / (float) Entries_.size());		
				unsigned int Cursor_Y = (unsigned int)(Cursor_H/2 + (vh_-20) - (vh_-140) * ((float)(Imin) / Entries_.size()));
				if(Cursor_H<5)Cursor_H=5;

				if(Y>vy_+BoxH && Y<vy_+BoxH + 20){
					if(Imax+1<=Entries_.size())	Imin++;					
				}else if(Y > vy_+ vh_-20 && Y < vy_+ vh_-0 ){
					if(Imin>0)Imin--;					
				}else if(Y < vy_+ vh_- 20  && Y > vy_ + (Cursor_Y-Cursor_H/2) ){					
					for(unsigned int i=0;i<Imax-Imin;i++)
					if(Imin>0)Imin--;					
				}else if(Y > vy_ + BoxH + 20     && Y < vy_ + (Cursor_Y-Cursor_H/2) ){	
					for(unsigned int i=0;i<Imax-Imin;i++)
					if(Imax+1<=Entries_.size()){	Imin++;	 Imax++;}								
				}				
			}
		}
	}else if(button == GLUT_MIDDLE_BUTTON ){
	}else if(button == GLUT_RIGHT_BUTTON){
	}else{
	}


	Menu_CleanUp();			
	if(frogObjects_->frogEvent_)Menu_Update(frogObjects_->frogEvent_);
	if(frogObjects_->frogGeom_ )Menu_Update(frogObjects_->frogGeom_->prim->getDaughter(0));

	return true;
}


	bool processSpecialKeys(int key, int x, int y){
		Menu_CleanUp();			
		if(frogObjects_->frogEvent_)Menu_Update(frogObjects_->frogEvent_);
		if(frogObjects_->frogGeom_ )Menu_Update(frogObjects_->frogGeom_->prim->getDaughter(0));

		switch(key) {
			case GLUT_KEY_DOWN : 
			case GLUT_KEY_RIGHT : 
				if(Imax+1<Entries_.size())	Imin++;
				break;
			case GLUT_KEY_UP :
			case GLUT_KEY_LEFT :
				if(Imin>0)Imin--;
				break;
			case GLUT_KEY_PAGE_UP : 
				for(unsigned int i=0;i<20;i++)
				if(Imin>0)Imin--;					
				break;
			case GLUT_KEY_PAGE_DOWN : 
				for(unsigned int i=0;i<20;i++)
				if(Imax+1<Entries_.size()){	Imin++;	 Imax++;}
				break;
			case GLUT_KEY_HOME:
				Imin = 0;
				break;
			case GLUT_KEY_END:
				Imin = Entries_.size()-(Imax-Imin)-1;
				break;
			default :
				return false;
				break;
		}



		return true;
	}


};


#endif

